//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Ms3FrameListUnit.h"
#include "Ms3ViewerUnit.h"
#include "Ms3Recorder.h"
#include "DataFrame.h"
#include "display\ValueStringFormatter.h"
#include "device\MiniscopeDeviceInterface.h"
#include <time.h>
#include <stdio.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmMs3FrameList *frmMs3FrameList;
//---------------------------------------------------------------------------
__fastcall TfrmMs3FrameList::TfrmMs3FrameList(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------

void TfrmMs3FrameList::UpdateView(void)
{
	bool bInvalidate = false;
	if (lvFrames->Items->Count != (int)frmMs3Viewer->frame_cnt ||
		!lvFrames->Selected ||
		lvFrames->Selected->Index != (int)frmMs3Viewer->current_frame)
	{
		bInvalidate = true;
	}
	
	if (lvFrames->Items->Count != (int)frmMs3Viewer->frame_cnt)
	{
		lvFrames->Items->Count = frmMs3Viewer->frame_cnt;
	}

	if (lvFrames->Items->Count > 0)
	{
		lvFrames->Items->Item[frmMs3Viewer->current_frame]->Selected = true;
		lvFrames->Items->Item[frmMs3Viewer->current_frame]->Focused = true;
	}
	
	if (bInvalidate)
	{
		lvFrames->Invalidate();
	}
}

void __fastcall TfrmMs3FrameList::lvFramesData(TObject *Sender, TListItem *Item)
{
	int id = Item->Index;
	struct S_DATAFRAME desc;
	int status = Ms3Recorder::Instance().GetFrameDesc(id, desc);
	if (status)
		return;
	Item->Caption = id + 1;

	char* timeline = ctime( & ( desc.timestamp.time ) );
	timeline[19]=0;
	char buf[64];
	sprintf(buf, "%15s.%03hu", &timeline[4], desc.timestamp.millitm);
	Item->SubItems->Add(buf);

	float fSamplVal = (float)1.0 / desc.fDivX;
	Item->SubItems->Add(ValueStringFormatter::FreqToStr(fSamplVal, 1).c_str());

	Item->SubItems->Add(desc.buffer_size);

	Item->SubItems->Add(DeviceInterface::GetTriggerTypeName((E_TRIGGER_TYPE)desc.trigger_type));

	Item->SubItems->Add(DeviceInterface::GetCouplingTypeName((E_COUPLING_TYPE)desc.coupling));
}
//---------------------------------------------------------------------------
void __fastcall TfrmMs3FrameList::lvFramesSelectItem(TObject *Sender,
      TListItem *Item, bool Selected)
{
	if (!Selected)
		return;
	frmMs3Viewer->current_frame = Item->Index;
	frmMs3Viewer->LoadFrame();
}
//---------------------------------------------------------------------------
