/** \file
	\brief Miniscope changelog
*/

/** \page changelog Changelog

Version 0.00.07:
	- FIXED: no coupling type update at startup
	- FIXED: plot not updated after resetting zoom/offset
	- FIXED: X axis labels incorrectly displayed in spectrum analyzer mode when there is no data
	- FIXED: no settings update when sensitivity/sampling/trigger trackbar position was changed using keyboard
	- added slow signal recorder mode
	- enabled main form hints, added hints for toolbar buttons
	- added progress bar representing received part of expected data buffer from device
	- armscope.dll: libusb updated to 0.1.12.1
	- turned off "Use dynamic RTL" option (no dependency to cc3270MT.dll)
	- cursors are drawn on top of actual plot line
	- current X and Y axis zoom displayed on toolbar
	- added build timestamp to "About" and build-tools\touch.exe to build chain
	- added Statistics.cpp/StatisticsUnit.cpp - calculation of min, max and avg value
	- added dialog on startup when no input device dll is selected
	- added option to export plot image to bitmap file (File menu)

Version 0.00.08
    - FIXED: AV at startup if input library was not found
	- data vector passed do display represents physical value, not ADC output
	- offset and sensitivity calibration for each sensitivity range (if supported by input dll)

Version 0.00.09
	- FIXED: leading backspace in default filename when saving plot as bitmap and default directory is empty
	- ScreenSnap changed for some of the windows
	- added fancy hexagonal toolbar for plot (toggled by middle button)
	- selecting input device dll is now required, application will abort if device is not selected
	- added feedback form for loading device, initial loading moved to TfrmMain::OnShow
	- added simple plot data export to JSON and CSV format

Version 0.00.10
	- FIXED: random halt (typically with continuous trigger when system CPU load was high);
	VCL code (reading GUI state) removed from CallbackTriggerFn
	- FFT is calculated only after receiving full expected data frame from device

Version 0.00.11
	- FIXED: zoom was not cleared in recorder mode; simplified ActionZoomClearExecute
	- display: auto adjusting plot zoom and position for Y axis
	- display: added enum E_OFFSET_ACTION to Display class to allow leave offset untouched or clear it calling SetZoom
	- display: X offset is not changing when using Y axis zoom, Y offset is not changing
	when using X axis zoom

Version 0.00.12
	- FIXED: plot grid visibility options had no meaning in recorder mode
	- statistics updated after receiving full frame (same as FFT) and when statistics
	window is opened if full frame is already received
	- statistics window is not shown until device dll is loaded
	- added signal frequency measuring to statistics
	- added transparency setting to plot toolbox; setting is ignored if tranparency
	is not supported by OS (i.e. Win98)

Version 0.00.13
	- FIXED: project failed to build if there was space in project path
	(incorrect Pre-Build tools command), thanks to ukasz for report
	- FIXED: FFT was not displayed or displayed incorrectly if data buffer size
	was not power of two
	- SOLVED: high CPU usage by plot was side effect of using CodeGuard; with CodeGuard
	turned off (release build) drawing 14k samples takes less than 3 ms on
	Pentium M @ 600 MHz + ATI R9000 set (30 times faster than previously), d'oh!
	- added auto adjusting plot zoom and position for X axis
	- nicer log window
	- added TimeCounter.h - utility to measure execution time
	- added info about CodeGuard usage and debug build in About window

Version 0.00.14
	- FIXED: on some low-end computers there was blank rectangle (size of the save dialog)
	visible on image exported to clipboard or file
	- FIXED: incorrectly displayed sensitivity, sampling and incorrect
	visibility state of buttons related to trigger types when failed to connect to device
	on startup
	- added JSON file viewer
	- oscilloscope control panel is disabled if device is not connected
	- receive progress bar is hidded when not waiting for data
	- reduced size of exported bitmap file (changed format to 8 bit)
	- added standard File/Exit action

Version 0.00.15
	- added signal processing framework with few simple filters based on factory pattern
	- added CompileTimeChecker.h (STATIC_CHECK(expr, msg) macro)
	- changes to data collecting and drawing: data is buffered in dataOscTmp vector and
	written to main/displayed buffer (dataOsc) only when temporary buffer acquired full
	frame or main buffer is not filled yet
	- creating TBitmap for data export is now part of ConcreteDisplay
	- FIXED not working saving plot to bitmap and clipboard on windows vista
	(thanks Jakub Nizioek for the report)

Version 0.00.16
	- FIXED no display update/redraw after loading JSON file
	(thanks Jakub Nizioek for the report)
    - added data recording to custom binary format (MS3)
*/
